Attribute VB_Name = "modMap"
Option Explicit

'Continuum SkinMap Maker
'By: Star Matrix

Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Public Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long

Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

Public Declare Function SHFileOperation Lib "shell32.dll" Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) As Long

Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public Type SHFILEOPSTRUCT
    hwnd      As Long
    wFunc     As Long
    pFrom     As String
    pTo       As String
    fFlags    As Integer
    fAborted  As Boolean
    hNameMaps As Long
    sProgress As String
End Type

Public Const FO_COPY = &H2
Public Const FOF_NOCONFIRMATION = &H10
Public Const FOF_SILENT = &H4

Public Function GetFromINI(Section As String, Key As String, Directory As String) As String
   Dim strBuffer As String
   strBuffer = String(750&, Chr(0))
   Key$ = LCase$(Key$)
   GetFromINI$ = Left(strBuffer, GetPrivateProfileString(Section$, ByVal Key$, "", strBuffer, Len(strBuffer), Directory$))
End Function

Public Sub WriteToINI(Section As String, Key As String, KeyValue As String, Directory As String)
    Call WritePrivateProfileString(Section$, UCase$(Key$), KeyValue$, Directory$)
End Sub

Public Function AppPath() As String
    AppPath$ = App.Path & "\mapconfig.ini"
End Function

Public Sub GetPosition(FRM As Form)
    Dim strForm As String
    Dim bytWindowState As Byte
    Dim intLeft As Integer
    Dim intTop As Integer
    Dim intWidth As Integer
    Dim intHeight As Integer
    strForm$ = FRM.Name
    bytWindowState = CByte(GetFromINI(strForm$ & "pos", "windowstate", AppPath$))
    intLeft% = CInt(GetFromINI(strForm$ & "pos", "left", AppPath$))
    intTop% = CInt(GetFromINI(strForm$ & "pos", "top", AppPath$))
    intWidth% = CInt(GetFromINI(strForm$ & "pos", "width", AppPath$))
    intHeight% = CInt(GetFromINI(strForm$ & "pos", "height", AppPath$))
    With FRM
        .Move intLeft%, intTop%, intWidth%, intHeight%
        .WindowState = bytWindowState
    End With
End Sub

Public Sub SetPosition(FRM As Form)
    Dim strForm As String
    With FRM
        strForm$ = .Name
        Select Case .WindowState
            Case 0
                Call WriteToINI(strForm$ & "pos", "windowstate", CStr(.WindowState), AppPath$)
                Call WriteToINI(strForm$ & "pos", "left", CStr(.Left), AppPath$)
                Call WriteToINI(strForm$ & "pos", "top", CStr(.Top), AppPath$)
                Call WriteToINI(strForm$ & "pos", "width", CStr(.Width), AppPath$)
                Call WriteToINI(strForm$ & "pos", "height", CStr(.Height), AppPath$)
            Case 1
                Call WriteToINI(strForm$ & "pos", "windowstate", CStr(.WindowState), AppPath$)
            Case 2
                Call WriteToINI(strForm$ & "pos", "windowstate", CStr(.WindowState), AppPath$)
        End Select
    End With
End Sub

Public Function Inverse(Color As String) As Long
    Dim strRGB As String
    Dim intR_a As Integer
    Dim intG_a As Integer
    Dim intB_a As Integer
    Dim intR_b As Integer
    Dim intG_b As Integer
    Dim intB_b As Integer
    strRGB$ = str_HEX(Color$)
    intR_a% = Val("&H" + Right(strRGB$, 2))
    intG_a% = Val("&H" + Mid(strRGB$, 3, 2))
    intB_a% = Val("&H" + Left(strRGB$, 2))
    intR_b% = 255 - intR_a%
    intG_b% = 255 - intG_a%
    intB_b% = 255 - intB_a%
    Inverse& = RGB(intR_b%, intG_b%, intB_b%)
End Function

Public Function str_HEX(RGB As String) As String
    Dim strHex As String
    Dim strCol As String
    Dim i As Byte
    strCol$ = RGB$
    strHex$ = Hex(strCol$)
    i = Len(strHex$)
    Select Case i
        Case 5
            strHex$ = "0" & strHex$
        Case 4
            strHex$ = "00" & strHex$
        Case 3
            strHex$ = "000" & strHex$
        Case 2
            strHex$ = "0000" & strHex$
        Case 1
            strHex$ = "00000" & strHex$
    End Select
    str_HEX$ = strHex$
End Function

Public Sub SavePic()
    'www.TheScarms.com
    Dim lngFileOperation As Long
    Dim lngResult As Long
    Dim lngFlags As Long
    Dim SHFileOp As SHFILEOPSTRUCT
    Screen.MousePointer = vbHourglass
    lngFileOperation = FO_COPY
    lngFlags = lngFlags Or FOF_SILENT
    lngFlags = lngFlags Or FOF_NOCONFIRMATION
    With SHFileOp
        .wFunc = lngFileOperation
        .pFrom = Map(0) & vbNullChar & vbNullChar
        .pTo = App.Path & vbNullChar & vbNullChar
        .fFlags = lngFlags
    End With
    lngResult = SHFileOperation(SHFileOp)
    Screen.MousePointer = vbDefault
    If lngResult <> 0 Or SHFileOp.fAborted Then Exit Sub
End Sub

Public Sub SaveHTML()
    'dos
    On Error Resume Next
    Open App.Path & "\" & Map(2) & ".html" For Output As #1
    Print #1, frmMap.txtMap.Text
    Close #1
End Sub

Public Sub OpenHTML(Path As String)
    Dim TextString As String
    On Error Resume Next
    Open Path$ For Input As #1
    TextString$ = Input(LOF(1), #1)
    Close #1
    frmMap.txtMap.Text = TextString$
End Sub

Public Sub SaveSettings()
    Dim i As Byte
    Dim X As Byte
    For i = 0 To 5
        Call WriteToINI("map", CStr(i), Map(i), App.Path & "\" & Map(2) & ".ini")
    Next i
    For i = 0 To Rects
        For X = 0 To 8
            Call WriteToINI(CStr(i), CStr(X), MapRect(i, X), App.Path & "\" & Map(2) & ".ini")
        Next X
    Next i
    Call WriteToINI("color", "color", CStr(Color), App.Path & "\" & "\" & Map(2) & ".ini")
    Call WriteToINI("rects", "rects", CStr(Rects), App.Path & "\" & "\" & Map(2) & ".ini")
End Sub
